#define _POSIX_C_SOURCE  200112L
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// dimensione massima in bytes di una riga nel file di input
#define MAX_LINE 1024

int reverse(char *str, char **reversed) {
    size_t len = strlen(str);
    *reversed = realloc(*reversed, (len+1)*sizeof(char));
    if (*reversed == NULL) {
	perror("realloc");
	return -1;
    }
    int i=0;
    reversed[0][len]='\0';
    while(len--) reversed[0][i++] = str[len];
    return 0;
}

void tokenizer_reverse(char *stringa, FILE *out) {
    stringa[strlen(stringa)+1]='\0'; 
    char *tmpstr=NULL, *token_reversed = NULL;
    char *token = strtok_r(stringa, " ", &tmpstr);
    while (token) {
	if (reverse(token, &token_reversed) < 0) return;
	fprintf(out, "%s\n", token_reversed);
	token = strtok_r(NULL, " ", &tmpstr);
    }
    if (token_reversed) free(token_reversed);
}

int main(int argc, char *argv[]) {
    int err=-1;
    if (argc < 3) {
	fprintf(stderr, "usa: %s <filein> <fileout> [a]\n\n", argv[0]);
	return err;
    }
    char *filein  = argv[1];
    char *fileout = argv[2];
    int append = 0;
    if (argc > 3 && argv[3][0]=='a') append = 1;

    FILE* in=NULL, *out = NULL;
    char *line = malloc(MAX_LINE*sizeof(char));
    if (!line) {
	perror("malloc");
	goto error;
    }
    
    in = fopen(filein, "r");
    if (in == NULL) {
	fprintf(stderr, "Il file in input \"%s\" non esiste o non puo' essere aperto in lettura\n", filein);
	goto error;
    }
    out = NULL;
    out = fopen(fileout, (append?"a":"w") );
    if (out == NULL) {
	fprintf(stderr, "Impossibile aprire il file \"%s\" in scrittura\n", fileout);
	goto error;
    }
    while(fgets(line, MAX_LINE, in) != NULL) {
	if (line[strlen(line)-1] != '\n') {
	    fprintf(stderr,"Stringa troppo lunga, il massimo e': %d\n", MAX_LINE);	    
	    goto error;
	} else {
	    line[strlen(line)-1] = '\0';
	    tokenizer_reverse(line, out);
	}
    }
    if (!feof(in)) {
	fprintf(stderr, "Errore nella lettura del file \"%s\"\n", filein);
	goto error;
    }
    err=0;
    
 error:        
    if (line) free(line);
    if (in) fclose(in);
    if (out) fclose(out);
    return err;
}
